#include "NTC.h"
#include "intrins.h"
 
 
 
 
 
 
void NTC_Init(void)
{
    P0n_pure_input(0x08);
    ADCTIM = 0x3f;		// ADC ڲʱADCʱ佨ֵ
    ADCCFG = 0x2f;		// ADC ʱΪϵͳʱ/2/16/16
    ADC_CONTR = 0x8B; //ʹ ADC ģ

} 
//========================================================================
// : u16 Get_ADC12bitResult(u8 channel)
// : ѯһADC.
// : channel: ѡҪתADC.
// : 12λADC.
// 汾: V1.0, 2012-10-22
//========================================================================
u16 Get_ADC12bitResult(u8 channel)  //channel = 0~15
{
    ADC_RES = 0;
    ADC_RESL = 0;

    ADC_CONTR = (ADC_CONTR & 0xF0) | 0x40 | channel;    // AD ת
    _nop_();
    _nop_();
    _nop_();
    _nop_();

    while((ADC_CONTR & 0x20) == 0)  ;   //wait for ADC finish
    ADC_CONTR &= ~0x20;     //ADC־
    return  (((u16)ADC_RES << 8) | ADC_RESL);
}


//  MF52E 10K at 25, B = 3950, ADC = 12 bits
u16 code temp_table[]={
        13,    //;-40  0
        14,    //;-39  1
        15,    //;-38  2
        16,    //;-37  3
        17,    //;-36  4
        18,    //;-35  5
        19,    //;-34  6
        20,    //;-33  7
        21,    //;-32  8
        23,    //;-31  9
        24,    //;-30  10
        26,    //;-29  11
        27,    //;-28  12
        29,    //;-27  13
        31,    //;-26  14
        32,    //;-25  15
        34,    //;-24  16
        36,    //;-23  17
        39,    //;-22  18
        41,    //;-21  19
        43,    //;-20  20
        46,    //;-19  21
        48,    //;-18  22
        51,    //;-17  23
        54,    //;-16  24
        57,    //;-15  25
        60,    //;-14  26
        64,    //;-13  27
        67,    //;-12  28
        71,    //;-11  29
        75,    //;-10  30
        79,    //;-9   31
        83,    //;-8   32
        87,    //;-7   33
        92,    //;-6   34
        97,    //;-5   35
        102,    //;-4   36
        107,    //;-3   37
        113,    //;-2   38
        119,    //;-1   39
        125,    //;0    40
        131,   //;1    41
        137,   //;2    42
        144,   //;3    43
        151,   //;4    44
        159,   //;5    45
        166,   //;6    46
        174,   //;7    47
        183,   //;8    48
        191,   //;9    49
        200,   //;10   50
        209,   //;11   51
        219,   //;12   52
        229,   //;13   53
        239,   //;14   54
        250,   //;15   55
        261,   //;16   56
        272,   //;17   57
        284,   //;18   58
        297,   //;19   59
        309,   //;20   60
        322,   //;21   61
        336,   //;22   62
        350,   //;23   63
        364,   //;24   64
        379,   //;25   65
        395,   //;26   66
        410,   //;27   67
        427,   //;28   68
        443,   //;29   69
        460,   //;30   70
        478,   //;31   71
        496,   //;32   72
        515,   //;33   73
        534,   //;34   74
        554,   //;35   75
        574,   //;36   76
        594,   //;37   77
        615,   //;38   78
        637,   //;39   79
        659,   //;40   80
        681,   //;41   81
        704,   //;42   82
        728,   //;43   83
        752,   //;44   84
        776,   //;45   85
        801,   //;46   86
        827,   //;47   87
        853,   //;48   88
        879,   //;49   89
        906,   //;50   90
        933,   //;51   91
        961,   //;52   92
        989,   //;53   93
        1017,   //;54   94
        1046,   //;55   95
        1075,   //;56   96
        1105,   //;57   97
        1134,   //;58   98
        1165,   //;59   99
        1195,   //;60   100
        1226,   //;61   101
        1257,   //;62   102
        1289,   //;63   103
        1320,   //;64   104
        1352,   //;65   105
        1385,   //;66   106
        1417,   //;67   107
        1450,   //;68   108
        1482,   //;69   109
        1515,   //;70   110
        1548,   //;71   111
        1581,   //;72   112
        1615,   //;73   113
        1648,   //;74   114
        1681,   //;75   115
        1715,   //;76   116
        1748,   //;77   117
        1781,   //;78   118
        1815,   //;79   119
        1848,   //;80   120
        1882,   //;81   121
        1915,   //;82   122
        1948,   //;83   123
        1981,   //;84   124
        2014,   //;85   125
        2047,   //;86   126
        2079,   //;87   127
        2112,   //;88   128
        2144,   //;89   129
        2176,   //;90   130
        2208,   //;91   131
        2240,   //;92   132
        2271,   //;93   133
        2302,   //;94   134
        2333,   //;95   135
        2364,   //;96   136
        2394,   //;97   137
        2424,   //;98   138
        2454,   //;99   139
        2483,   //;100  140
        2513,   //;101  141
        2541,   //;102  142
        2570,   //;103  143
        2598,   //;104  144
        2626,   //;105  145
        2653,   //;106  146
        2680,   //;107  147
        2707,   //;108  148
        2733,   //;109  149
        2759,   //;110  150
        2785,   //;111  151
        2810,   //;112  152
        2835,   //;113  153
        2859,   //;114  154
        2883,   //;115  155
        2907,   //;116  156
        2931,   //;117  157
        2954,   //;118  158
        2976,   //;119  159
        2998    //;120  160
};

/********************  ¶ ***********************************************/
// : 0Ӧ-40.0, 400Ӧ0, 625Ӧ25.0, 1600Ӧ120.0. 
// Ϊͨ, ADCΪ12bitADCֵ.
// ·㷨: Coody
/**********************************************/

#define     D_SCALE     10     //Ŵ, Ŵ10ǱһλС
u16 get_temperature(u16 adc )
{
    u16 code *p;
    u16 i;
    u8  j,k,min,max;
  //  adc = Get_ADC12bitResult(11);
   adc = 4096 - adc;   //Rtӵ
    p = temp_table;
    if(adc < p[0])      return (0xfffe);
    if(adc > p[160])    return (0xffff);
    
    min = 0;        //-40
    max = 160;      //120

    for(j=0; j<5; j++)  //Էֲ
    {
        k = min / 2 + max / 2;
        if(adc <= p[k]) max = k;
        else            min = k;
    }
         if(adc == p[min])  i = min * D_SCALE;
    else if(adc == p[max])  i = max * D_SCALE;
    else    // min < temp < max
    {
        while(min <= max)
        {
            min++;
            if(adc == p[min])   {i = min * D_SCALE; break;}
            else if(adc < p[min])
            {
                min--;
                i = p[min]; //min
                j = (adc - i) * D_SCALE / (p[min+1] - i);
                i = min;
                i *= D_SCALE;
                i += j;
                break;
            }
        }
    }
    return i;
}


#endif
